/*
  Copyright 2021 Kakao Corp.

  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.
  You may obtain a copy of the License at

     http://www.apache.org/licenses/LICENSE-2.0

  Unless required by applicable law or agreed to in writing, software
  distributed under the License is distributed on an "AS IS" BASIS,
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  See the License for the specific language governing permissions and
  limitations under the License.
 */
package com.kakao.sdk.partner.friend

import com.kakao.sdk.partner.friend.model.*

/**
 * @suppress
 */
internal object Constants {
    const val KEY_BUNDLE = "key.bundle"
    const val KEY_RESULT_RECEIVER = "key.result.receiver"
    const val KEY_SELECTED_TOTAL_COUNT = "key.selected.totalcount"
    const val KEY_SELECTED_FRIENDS = "key.selected.friends"
    const val KEY_SELECTED_CHAT = "key.selected.chat"
    const val KEY_EXCEPTION = "key.exception"
    const val KEY_VIEW_SETTING_PARAM = "key.view.setting.param"
    const val KEY_FRIEND_PICKER_PARAM = "key.friend.picker.param"
    const val KEY_CHAT_PICKER_PARAM = "key.chat.picker.param"
    const val KEY_IS_SINGLE = "key.issingle"
    const val KEY_IS_POPUP = "key.ispopup"
    const val KEY_IS_CHAT_MEMBER_PICKER = "key.ischatmemberpicker"
    const val KEY_IS_TAB = "key.istab"
    const val KEY_PICKER_TYPE = "key.picker.type"
    const val FRIEND_PICKER = "friend"
    const val CHAT_PICKER = "chat"
    const val TAB_PICKER = "tab"

    const val MULTI_PICKER_MIN_PICKABLE_COUNT = 1
    const val MULTI_PICKER_MAX_PICKABLE_COUNT = 100
    const val PARTNER_FRIENDS_API_LIMIT = 10000
    const val PARTNER_CHATS_API_LIMIT = 10000

    const val V1_FRIENDS_PATH = "v1/friends/sdk"
    const val V2_USER_SCOPES = "v2/user/scopes/sdk"

    const val FRIEND_TYPE = "friend_type"
    const val FRIEND_FILTER = "friend_filter"
    const val FRIEND_ORDER = "friend_order"
    const val OFFSET = "offset"
    const val LIMIT = "limit"
    const val ORDER = "order"
    const val COUNTRY_CODES = "country_codes"
    const val SCOPE_GROUP = "scope_group"
    const val TARGET_IDS= "target_ids"

    const val V1_CHATS_PATH = "/v1/api/talk/chat/list/sdk"
    const val FILTER = "filter"

    const val V1_CHAT_MEMBERS_PATH = "/v1/api/talk/members/sdk"
    const val CHAT_ID = "chat_id"
    const val FRIENDS_ONLY = "friends_only"
    const val INCLUDE_PROFILE = "include_profile"
    const val TOKEN = "token"

    // param default value
    val DEFAULT_PICKER_SERVICE_TYPE_FILTER = PickerServiceTypeFilter.TALK
    val DEFAULT_PICKER_FRIEND_FILTER = PickerFriendFilter.NONE
    val DEFAULT_PICKER_CHAT_FILTER = PickerChatFilter.REGULAR
    val DEFAULT_PICKER_VIEW_APPEARANCE = ViewAppearance.AUTO
    val DEFAULT_OS_FILTER = PickerUsingOsFilter.ALL
    val DEFAULT_PICKER_ORIENTATION = PickerOrientation.AUTO
    const val DEFAULT_ENABLE_SEARCH = true
    const val DEFAULT_ENABLE_INDEX = true
    const val DEFAULT_SHOW_MY_PROFILE = true
    const val DEFAULT_SHOW_FAVORITE = true
    const val DEFAULT_MAX_PICKABLE_COUNT = 30
    const val DEFAULT_MIN_PICKABLE_COUNT = 1
    const val DEFAULT_SHOW_PICKED_FRIENDS = true
    const val DEFAULT_DISPLAY_ALL_PROFILE = false
    const val DEFAULT_SHOW_FRIENDS_ONLY = true
}